;------------------------------------------------------------------------
; Solar Assembler example of making ELF32 object file
;
; build with
;	 sol_asm2 -elf64 test64_libc.asm test64_libc.obj
;
; link with:
;	gcc test64_libc.obj -o test64_libc
;
; run:
;	./test.exe 
;-----------------------------------------------------------------------
.use64

section "text"	 alias ".text"	class_code
section "data"	 alias ".data"	class_data

;-----------------------
; functions from libC
;-----------------------
extern 	puts	lin64
extern 	exit	lin64
extern	printf	lin64 varg

.entry main

.data
	msg_01		db	13,10,'Hi from Sol_Asm ELF64 LIBC sample',0
	msg_02		db	13,10,'Message number 02',0
	msg_fmt		db	13,10,'Printf message: number1=%x main_addr=%x ',13,10,10,0
	msg_fmt2	db	13,10,"Printf a1=%x a2=%x a3=%x a4=%x a5=%x a6=%x a7=%x a8=%x a9=%x a10=%x a11=%x a12=%x a13=%x a14=%x a15=%x ",13,10,10,0
	
	msg_proc1	db	13,10,'Message from my_proc',10,0
	msg_proc2	db	13,10,'Printf my_proc, %x %x ',10,0
	
.text


proc my_proc lin64
	arg	a_x1, a_y1, a_dx, a_dy
	local	l_m1, l_m2, l_m3, l_m4
	
	nop
	
	invoke	puts,msg_proc1	
	
	invoke	printf,msg_proc2,addr [a_x1], addr [l_m1] 
	
	nop
	ret
endp


main:
	;-------------------------------
	; use libc puts to write strings
	;-------------------------------
	invoke	puts,msg_01

	invoke	puts,msg_02

	;-----------------------
	; use libc printf
	;-----------------------
	invoke	printf,msg_fmt,888h,main

	invoke	printf,msg_fmt2,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15

	invoke	my_proc,1,2,3,4	
	
	;------------------------
	; libC exit function
	;------------------------
	invoke	exit,77h

	ret

;-----------------------------
; the end of this programm
;-----------------------------

